#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec2 TexCoords;
out vec3 FragPos;
out vec3 Normal;

uniform mat4 model;
uniform mat4 MVP;
uniform vec4 plane;

void main()
{
	vec4 worldPosition = model * vec4(position, 1.0);
	gl_ClipDistance[0] = dot(worldPosition, plane);

    gl_Position = MVP * vec4(position, 1.0f);
    FragPos = vec3(model * vec4(position, 1.0f));
    Normal = mat3(transpose(inverse(model))) * normal;
    TexCoords = texCoords;
}
